base-files: add support for staged sysupgrades from failsafe mode
[openwrt/openwrt.git] / package / base-files / files / sbin / sysupgrade
index f6b628e96ef6123ac4c6045a28270396059bf6bd..809e789f9f436aaeb47a906d46c94d5952583e5a 100755 (executable)
@@ -1,15 +1,19 @@
 #!/bin/sh
+
 . /lib/functions.sh
+. /lib/functions/system.sh
 
 # initialize defaults
 RAMFS_COPY_BIN=""      # extra programs for temporary ramfs root
 RAMFS_COPY_DATA=""     # extra data files
+export MTD_CONFIG_ARGS=""
 export INTERACTIVE=0
 export VERBOSE=1
 export SAVE_CONFIG=1
 export SAVE_OVERLAY=0
-export DELAY=
+export SAVE_PARTITIONS=1
 export CONF_IMAGE=
+export CONF_BACKUP_LIST=0
 export CONF_BACKUP=
 export CONF_RESTORE=
 export NEED_IMAGE=
@@ -18,16 +22,17 @@ export FORCE=0
 export TEST=0
 
 # parse options
-while [ -n "$1" ]; do 
+while [ -n "$1" ]; do
        case "$1" in
                -i) export INTERACTIVE=1;;
-               -d) export DELAY="$2"; shift;;
                -v) export VERBOSE="$(($VERBOSE + 1))";;
                -q) export VERBOSE="$(($VERBOSE - 1))";;
                -n) export SAVE_CONFIG=0;;
                -c) export SAVE_OVERLAY=1;;
+               -p) export SAVE_PARTITIONS=0;;
                -b|--create-backup) export CONF_BACKUP="$2" NEED_IMAGE=1; shift;;
                -r|--restore-backup) export CONF_RESTORE="$2" NEED_IMAGE=1; shift;;
+               -l|--list-backup) export CONF_BACKUP_LIST=1; break;;
                -f) export CONF_IMAGE="$2"; shift;;
                -F|--force) export FORCE=1;;
                -T|--test) export TEST=1;;
@@ -44,10 +49,9 @@ done
 export CONFFILES=/tmp/sysupgrade.conffiles
 export CONF_TAR=/tmp/sysupgrade.tgz
 
-export ARGV="$*"
-export ARGC="$#"
+IMAGE="$1"
 
-[ -z "$ARGV" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
+[ -z "$IMAGE" -a -z "$NEED_IMAGE" -o $HELP -gt 0 ] && {
        cat <<EOF
 Usage: $0 [<upgrade-option>...] <image file or URL>
        $0 [-q] [-i] <backup-command> <file>
@@ -58,6 +62,7 @@ upgrade-option:
        -i           interactive mode
        -c           attempt to preserve all changed files in /etc/
        -n           do not save configuration over reflash
+       -p           do not attempt to restore the partition table after flash.
        -T | --test
                     Verify image and config .tar.gz but do not actually flash.
        -F | --force
@@ -75,12 +80,15 @@ backup-command:
                     restore a .tar.gz created with sysupgrade -b
                     then exit. Does not flash an image. If file is '-',
                     the archive is read from stdin.
+       -l | --list-backup
+                    list the files that would be backed up when calling
+                    sysupgrade -b. Does not create a backup file.
 
 EOF
        exit 1
 }
 
-[ -n "$ARGV" -a -n "$NEED_IMAGE" ] && {
+[ -n "$IMAGE" -a -n "$NEED_IMAGE" ] && {
        cat <<-EOF
                -b|--create-backup and -r|--restore-backup do not perform a firmware upgrade.
                Do not specify both -b|-r and a firmware image.
@@ -95,14 +103,20 @@ add_uci_conffiles() {
        local file="$1"
        ( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
                /etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
-               -type f 2>/dev/null;
+               -type f -o -type l 2>/dev/null;
          opkg list-changed-conffiles ) | sort -u > "$file"
        return 0
 }
 
 add_overlayfiles() {
        local file="$1"
-       find /overlay/etc/ -type f | sed \
+       if [ -d /overlay/upper ]; then
+               local overlaydir="/overlay/upper"
+       else
+               local overlaydir="/overlay"
+       fi
+       find $overlaydir/etc/ -type f -o -type l | sed \
+               -e 's,^/overlay\/upper/,/,' \
                -e 's,^/overlay/,/,' \
                -e '\,/META_[a-zA-Z0-9]*$,d' \
                -e '\,/functions.sh$,d' \
@@ -112,7 +126,8 @@ add_overlayfiles() {
 }
 
 # hooks
-sysupgrade_image_check="platform_check_image"
+sysupgrade_image_check="fwtool_check_image platform_check_image"
+sysupgrade_pre_upgrade="fwtool_pre_upgrade"
 [ $SAVE_OVERLAY = 0 -o ! -d /overlay/etc ] && \
        sysupgrade_init_conffiles="add_uci_conffiles" || \
        sysupgrade_init_conffiles="add_overlayfiles"
@@ -125,6 +140,7 @@ do_save_conffiles() {
        [ -z "$(rootfs_type)" ] && {
                echo "Cannot save config while running from ramdisk."
                ask_bool 0 "Abort" && exit
+               rm -f "$conf_tar"
                return 0
        }
        run_hooks "$CONFFILES" $sysupgrade_init_conffiles
@@ -133,8 +149,17 @@ do_save_conffiles() {
        v "Saving config files..."
        [ "$VERBOSE" -gt 1 ] && TAR_V="v" || TAR_V=""
        tar c${TAR_V}zf "$conf_tar" -T "$CONFFILES" 2>/dev/null
+
+       rm -f "$CONFFILES"
 }
 
+if [ $CONF_BACKUP_LIST -eq 1 ]; then
+       add_uci_conffiles "$CONFFILES"
+       cat "$CONFFILES"
+       rm -f "$CONFFILES"
+       exit 0
+fi
+
 if [ -n "$CONF_BACKUP" ]; then
        do_save_conffiles "$CONF_BACKUP"
        exit $?
@@ -156,8 +181,33 @@ type platform_check_image >/dev/null 2>/dev/null || {
        exit 1
 }
 
+case "$IMAGE" in
+       http://*)
+               wget -O/tmp/sysupgrade.img "$IMAGE"
+               IMAGE=/tmp/sysupgrade.img
+               ;;
+esac
+
+IMAGE="$(readlink -f "$IMAGE")"
+
+case "$IMAGE" in
+       '')
+               echo "Image file not found."
+               exit 1
+               ;;
+       /tmp/*) ;;
+       *)
+               v "Image not in /tmp, copying..."
+               cp -f "$IMAGE" /tmp/sysupgrade.img
+               IMAGE=/tmp/sysupgrade.img
+               ;;
+esac
+
+export ARGV="$IMAGE"
+export ARGC=1
+
 for check in $sysupgrade_image_check; do
-       ( eval "$check \"\$ARGV\"" ) || {
+       ( $check "$IMAGE" ) || {
                if [ $FORCE -eq 1 ]; then
                        echo "Image check '$check' failed but --force given - will update anyway!"
                        break
@@ -183,6 +233,7 @@ elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
        [ $TEST -eq 1 ] || do_save_conffiles
        export SAVE_CONFIG=1
 else
+       [ $TEST -eq 1 ] || rm -f "$CONF_TAR"
        export SAVE_CONFIG=0
 fi
 
@@ -190,18 +241,26 @@ if [ $TEST -eq 1 ]; then
        exit 0
 fi
 
+if [ $SAVE_PARTITIONS -eq 0 ]; then
+       touch /tmp/sysupgrade.always.overwrite.bootdisk.partmap
+else
+       rm -f /tmp/sysupgrade.always.overwrite.bootdisk.partmap
+fi
+
 run_hooks "" $sysupgrade_pre_upgrade
 
-ubus call system upgrade
-touch /tmp/sysupgrade
+install_bin /sbin/upgraded
+v "Commencing upgrade. All shell sessions will be closed now."
 
-kill_remaining TERM
-sleep 3
-kill_remaining KILL
+COMMAND='. /lib/functions.sh; include /lib/upgrade; do_upgrade_stage2'
 
-if [ -n "$(rootfs_type)" ]; then
-       v "Switching to ramdisk..."
-       run_ramfs '. /lib/functions.sh; include /lib/upgrade; do_upgrade'
+if [ -n "$FAILSAFE" ]; then
+       printf '%s\x00%s\x00%s' "$RAM_ROOT" "$IMAGE" "$COMMAND" >/tmp/sysupgrade
+       lock -u /tmp/.failsafe
 else
-       do_upgrade
+       ubus call system sysupgrade "{
+               \"prefix\": $(json_string "$RAM_ROOT"),
+               \"path\": $(json_string "$IMAGE"),
+               \"command\": $(json_string "$COMMAND")
+       }"
 fi